<?php
/**
* SimpleSAML auth plug-in for phpBB3
* Author: Drazenko Celjak (drazenko.celjak@srce.hr)
* Version 1.0
* last update 2009-02-05
* url: http://developer.aaiedu.hr/faq/phpbb3_simplesamlphp.php
*
*
* changelog 1.0
* fixed bug - plugin fetches users email
*
*/



/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* Configuration
*/
define('simpleSAMLphp_home', '/data/www/simplesamlphp_1_1');
define('simpleSAMLphp_base_url_path', 'https://forum.srce.hr:452/simplesaml');

require_once(simpleSAMLphp_home . '/www/_include.php');



/**
* Login function
*/
function login_saml(&$username, &$password)
{
	global $db, $config;
	
	$attributes = get_saml_auth();
		
	if ($attributes !== false) {
	
		$username = $attributes['hrEduPersonUniqueID'][0];
		
		$row = get_user_by_username_saml($username);
		
		if ($row === false) 
		{
			// succesful login, create user
			return array(
				'status'		=> LOGIN_SUCCESS_CREATE_PROFILE,
				'error_msg'		=> false,
				'user_row'		=> user_row_saml($attributes),
				'cp_data'		=> cp_data_saml($attributes),
			);
		}
		else if ($row['user_type'] == USER_INACTIVE || $row['user_type'] == USER_IGNORE)			
		{
			return array(
				'status'		=> LOGIN_ERROR_ACTIVE,
				'error_msg'		=> 'ACTIVE_ERROR',
				'user_row'		=> $row,
			);
		}				
		
		// successful login
		return array(
			'status'		=> LOGIN_SUCCESS,
			'error_msg'		=> false,
			'user_row'		=> $row,
		);
				
	}
		
	die('Error: Access denied.'); 
	
}



/**
* The session validation function checks whether the user is still logged in
*
* @return boolean true if the given user is authenticated or false if the session should be closed
*/
/*
function validate_session_saml(&$user)
{
	$simpleSAMLsession = SimpleSAML_Session::getInstance();
	return ($simpleSAMLsession->isValid('saml2')) ? true : false;
}
*/



function get_saml_auth()
{
	$config = SimpleSAML_Configuration::getInstance();
	$simpleSAMLsession = SimpleSAML_Session::getInstance();
	if (!$simpleSAMLsession->isValid('saml2') ) {
		SimpleSAML_Utilities::redirect(
			simpleSAMLphp_base_url_path  . '/saml2/sp/initSSO.php', 
			array('RelayState' => SimpleSAML_Utilities::selfURL())
		);
	}
	$attributes = $simpleSAMLsession->getAttributes();
	return isset($attributes['hrEduPersonUniqueID'][0]) ? $attributes : false;		
}


/**
* dirty thing
*/
function set_fake_params($attribs)
{
	global $user, $phpbb_root_path;
	
	$_POST['login'] = 'yes';
	$_POST['password'] = 'trAlAl1212vx87fz';
	
	$_POST['username'] = $attribs['hrEduPersonUniqueID'][0];
	$_COOKIE['username'] = $_POST['username'];
	
	$_POST['credential'] = '1234567890abcdef1234567890abcdef';
	$_COOKIE['credential'] = $_POST['credential'];
	
	$_POST['redirect'] = $phpbb_root_path . $user->page['page'];
	$_COOKIE['redirect'] = $_POST['redirect'];
	
	// $_POST['viewonline'] = 1;
}



/**
* This function generates an array which can be passed to the user_add function in order to create a user
*/
function user_row_saml($attrib)
{
	global $db, $user;
	// first retrieve default group id
	$sql = 'SELECT group_id
		FROM ' . GROUPS_TABLE . "
		WHERE group_name = '" . $db->sql_escape('REGISTERED') . "'
			AND group_type = " . GROUP_SPECIAL;
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	if (!$row)
	{
		trigger_error('NO_GROUP');
	}

	// generate user account data
	return array(		
		'username'		=> $attrib['hrEduPersonUniqueID'][0],
		'user_password'	=> phpbb_hash('.,.121hjhUj'), // dummy pass, it will work if switching to plain auth
		'user_email'	=> $attrib['mail'][0],
		'group_id'		=> (int) $row['group_id'],
		'user_type'		=> USER_NORMAL,
		'user_ip'		=> $user->ip,
	);
}



function cp_data_saml($attrib)
{
	global $db;

	$cp_data = array();
	
	$sql = 'SELECT f.* FROM ' . PROFILE_FIELDS_TABLE . " f WHERE field_name = 'name'";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);		
	
	if ($row)
	{
		$givenName = (isset($attrib['givenName']) && is_array($attrib['givenName'])) 
			? implode(' ', $attrib['givenName']) : '';
					
		$sn = (isset($attrib['sn']) && is_array($attrib['sn'])) 
			? implode(' ', $attrib['sn']) : '';
				
		$name = trim("$givenName $sn");
			
		if (strlen($name) > 0)
			$cp_data['pf_name'] = $name;
	}		
	return $cp_data;
}



function get_user_by_username_saml($username)
{
	global $db;
	$sql = 'SELECT * FROM ' . USERS_TABLE . " WHERE username = '" . $db->sql_escape($username) . "'";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);		
	if ($row)
	{
		return $row;
	}
	return false;
}

?>